package de.uniks.pmrisk;

import org.junit.Test;
import org.sdmlib.models.classes.Card;
import org.sdmlib.models.classes.ClassModel;
import org.sdmlib.models.classes.Clazz;
import org.sdmlib.models.classes.DataType;
import org.sdmlib.storyboards.Storyboard;

public class SDMLibModel {

	/**
	 * 
	 * @see <a href='../../../../doc/generateModel.html'>generateModel.html</a>
	 */
	@Test
	public void generateModel() {

		// container
		ClassModel model = new ClassModel("i.love.sdmlib");

		// classes
		Clazz risk = model.createClazz("Risk");

		Clazz player = model.createClazz("Player");

		Clazz unit = model.createClazz("Unit");

		Clazz continent = model.createClazz("Continent");

		Clazz country = model.createClazz("Country");

		// methods
		risk.withMethod("init");

		// attributes
		player.withAttribute("name", DataType.STRING);
		player.withAttribute("color", DataType.STRING);

		continent.withAttribute("value", DataType.INT);
		continent.withAttribute("name", DataType.STRING);

		country.withAttribute("name", DataType.STRING);

		// associations
		risk.withAssoc(player, "players", Card.MANY, "game", Card.ONE);
		risk.withAssoc(player, "winner", Card.ONE, "wonGame", Card.ONE);
		risk.withAssoc(player, "currentPlayer", Card.ONE, "playingGame", Card.ONE);
		risk.withAssoc(continent, "continents", Card.MANY, "game", Card.ONE);

		player.withAssoc(unit, "units", Card.MANY, "player", Card.ONE);
		player.withAssoc(player, "previousPlayer", Card.ONE, "nextPlayer", Card.ONE);
		unit.withAssoc(country, "country", Card.ONE, "units", Card.MANY);
		continent.withAssoc(country, "countries", Card.MANY, "continent", Card.ONE);
		country.withAssoc(country, "neighbor", Card.MANY, "neighbor", Card.MANY);

		model.generate();
		Storyboard storyboard = new Storyboard();
		storyboard.addClassDiagram(model);
		storyboard.dumpHTML();
	}
}
